.IFNDEF WS28XX_USERCODE
.EQU WS28XX_USERCODE=1

.CSEG

;-----------------------------------------------------------------------------
;->LEDCNT : [RO] zero based number of the LED, data is requested for
;  (RAMPZ): bank pointer to gammatable (required only, if RAMPZ exists and
;           gamma correction is used) 
;<-R0     : red
;  R1     : green
;  YH     : blue
;-----------------------------------------------------------------------------
;Flags/ZH:ZL: free for use
;Maximum runtime is 321 ticks, but consider warnings regarding "extra ticks"
;-----------------------------------------------------------------------------

	push R16							;  2
	push R17							;  2

	lds ZL,hueoffset					;  2

	tst LEDCNTL							;  1
	brne calchue						;  1

	lds R16,bcnt+0						;  2
	lds R17,bcnt+1						;  2
	lds YH,bcnt+2						;  2
	subi R16,Byte1(BDENOM)				;  1
	sbci R17,Byte2(BDENOM)				;  1
	sbci YH,Byte3(BDENOM)				;  1
	brcc bcstore						;  1

	subi R16,Byte1(-BNUMER)				;  1
	sbci R17,Byte2(-BNUMER)				;  1
	sbci YH,Byte3(-BNUMER)				;  1
	dec ZL								;  1
	sts hueoffset,ZL					;  2

bcstore:
	sts bcnt+0,R16						;  2
	sts bcnt+1,R17						;  2
	sts bcnt+2,YH						;  2

calchue:
	ldi R16,Low(HUESCALE)				;  1			calculate hue depending on LED no.
	ldi R17,High(HUESCALE)				;  1
	UMUL LEDCNTL,R16					;  2
	add ZL,R1							;  1
	UMUL LEDCNTL,R17					;  2
	add ZL,R0							;  1
	ldi R16,255							;  1			fixed saturation
	ldi R17,95							;  1			and brightness

.INCLUDE "ws28xx_hsb2rgb.asm"			; 32			transform into RGB color space	
.INCLUDE "ws28xx_gamma.asm"				; 13			compensate human perception curve

	pop R17								;  2
	pop R16								;  2
										; --
										; 89			worst case +(5*38)=279 for ATtiny->safe in time
				

.ENDIF
